<template>
  <div class="main-container fr-p-2w">
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <AtomAlert
      v-else-if="error"
      :alert-type="AlertType.Error"
      message="Les statistiques de la répartion des structures de rattachement n'ont pas pu être chargées."
    />
    <template v-else-if="ministereStructureCounts">
      <h2 class="fr-h5">Structures de rattachement</h2>
      <StatsList
        v-if="ministereStructureCounts.length"
        :total-count="beneficiaryCount"
        :stats="ministereStructureCounts"
        stats-bar
      />
      <p v-else>
        Commencez à
        <NuxtLink
          :to="Routes.BeneficiariesAdd"
          target="_self"
          >créer des fiches de bénéficiaires</NuxtLink
        >
        pour voir apparaître les statistiques de la répartition des structures
        de rattachement.
      </p>
    </template>
  </div>
</template>

<script setup>
  import { MINISTERE_STRUCTURE_OPTIONS } from '~/utils/constants/beneficiary'
  import { AlertType } from '~~/utils/constants/alert'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { labelOrUnprovided } from '~~/utils/stats'
  import { Routes } from '~/utils/routing/routes'

  const { $getItems } = useNuxtApp()

  const props = defineProps({
    beneficiaryCount: {
      type: Number,
      required: true
    },
    filters: {
      type: Object,
      required: true
    }
  })

  const {
    data: ministereStructureCounts,
    pending,
    error,
    refresh
  } = useLazyAsyncData(
    'ministereStructureCounts',
    loadMinistereStructureCounts,
    {
      server: false
    }
  )

  watch(() => props.filters, refresh)

  async function loadMinistereStructureCounts() {
    const res = await $getItems('beneficiary', {
      groupBy: 'ministere_structure',
      aggregate: { countDistinct: 'id' },
      filter: props.filters
    })

    if (res.status === 200) {
      const ministereStructureResCounts = res.data.data.map(
        ministereStructure => ({
          key: ministereStructure.ministere_structure,
          label: labelOrUnprovided(
            ministereStructure.ministere_structure,
            MINISTERE_STRUCTURE_OPTIONS
          ),
          count: parseInt(ministereStructure.countDistinct.id)
        })
      )
      ministereStructureResCounts.sort((a, b) => b.count - a.count)
      return ministereStructureResCounts
    }
    throw new Error(errorResponseMessage(res))
  }
</script>
